/*
 * DS_Common.h
 *
 * Created: 2014/02/28 5:54:29
 *  Author: Yaasan
 */ 


#ifndef DS_COMMON_H_
#define DS_COMMON_H_

#define ADDR_MM2     0x0000 // MM2 locomotive
#define ADDR_SX1     0x0800 // Selectrix (old) locomotive
#define ADDR_MFX     0x4000 // MFX locomotive
#define ADDR_SX2     0x8000 // Selectrix (new) locomotive
#define ADDR_DCC     0xC000 // DCC locomotive
#define ADDR_ACC_SX1 0x2000 // Selectrix (old) magnetic accessory
#define ADDR_ACC_MM2 0x2FFF // MM2 magnetic accessory
#define ADDR_ACC_DCC 0x3800 // DCC magnetic accessory

#define SPEEDSTEP_DCC28 0
#define SPEEDSTEP_DCC14 1
#define SPEEDSTEP_DCC127 2
#define SPEEDSTEP_MM14 0
#define SPEEDSTEP_MM28 1

#define TIME_DEAD 1

#define PIN_DCC_A	21
#define PIN_DCC_B	20



void DS_GateOff(void);
void DS_OutputOff(void);
void DS_OutputBrake(void);
void DS_Power(uint8_t inMode);
uint8_t DS_IsPowerOn(void);
void DS_WriteBit(uint8_t inBit);
void DS_WaitSec(uint8_t inSec);
uint8_t DS_CalculateCRC(uint8_t* inPackets, uint8_t inLen);
uint8_t DS_CalcSpeedStep(short inSpeed, uint8_t inDiv);
uint8_t DS_GetLocIDProtocol(uint8_t address);
uint8_t DS_ABSdiff(uint8_t inUpper, uint8_t inLower);
void DS_WaitClk(uint8_t inTime4us);
void DS_InitWaitClkX(void);
void DS_WaitClkX(uint8_t inWaitTime);

#endif /* DS_COMMON_H_ */