
/*
 * DS_DCC.h
 *
 * Created: 2014/02/28 5:54:29
 *  Author: Yaasan
 */ 


#ifndef DS_DCC_H_
#define DS_DCC_H_


#define TIME_DCC_0AX 210 /* 10Xus, こちらは長くても問題なし */
#define TIME_DCC_0BX 210 /* 10Xus, こちらは長くても問題なし */
#define TIME_DCC_1AX 110 /* 58us - 2.6us(Deadtime) */
#define TIME_DCC_1BX 110 /* 58us - 2.6us(Deadtime) */
#define TIME_DCC_BIDI_CUTOUTSTART 57 /* 29us Railcom BiDi Cutout */
#define TIME_DCC_BIDI_ENDCUTOUTTIME  445 /* 454us */
#define TIME_DCC_BIDI_PREAMBLE 12

#define DCCPREAMBLE_DEFAULT		16		/**< 通常パケット用 */
#define DCCPREAMBLE_CV			24		/**< CVパケット用 */


extern uint8_t gEndBitPattern;


void DCC_Init();

void DCC_SendInitialPacket(uint8_t inPreambleCnt);
void DCC_SendPackets(uint8_t* inPackets, uint8_t inLen);
void DCC_SendPacketsEx(uint8_t *inPackets, uint8_t inLen, uint8_t inPreambleCnt);
void DCC_SendPreamble(uint8_t inSize);
void DCC_SendByte(uint8_t inData);
void DCC_SendBit(uint8_t inBit);

uint8_t DCC_decodeSpeedStep28(short speed, uint8_t direction);
uint8_t DCC_decodeSpeedStep127(short speed, uint8_t direction);
uint8_t DCC_decodeSpeedStep14(short speed, uint8_t direction, uint8_t aFunction);
uint8_t DCC_decodeFunction(uint8_t function, uint8_t power, uint64_t *inFuncBuf);
uint8_t DCC_decodeFunctionRaw(uint8_t function, uint64_t *inFuncBuf);

#endif /* DS_DCC_H_ */