//////////////////////////////////////////////////////////////////////////////////
// 
// DSairlite Sharemem module
// Copyright(C)'2023- DesktopStation
// 
// 本ソフトウェアは上記の著作者によって開発されたものであり、商用利用には
// ライセンス契約が必要となります。
// 
//////////////////////////////////////////////////////////////////////////////////
//

#include "ShareMemManager.h"


//初期化する
ShareMemManager::ShareMemManager()
{
	
	Clear();
	
}

void ShareMemManager::Clear()
{
	
	for (int i = 0; i < SHAREMEM_ACCSIZE; i++)
	{
		buffer_accessories[i] = 0;
	}


}

void ShareMemManager::Init()
{
	

	
}



//---------------------------------------------------------------------------
// process
//---------------------------------------------------------------------------

void ShareMemManager::Process()
{

}

void ShareMemManager::ClearShareMem()
{
	buffer_sharedStatusMem[0] = 0x4e;	//PWR
	buffer_sharedStatusMem[1] = 0x2c;	//カンマ
	buffer_sharedStatusMem[2] = 0x30;	//ERR
	buffer_sharedStatusMem[3] = 0x2c;	//カンマ
	buffer_sharedStatusMem[4] = FIRMWARE_VER;	//VER
	buffer_sharedStatusMem[5] = 0x2c;	//カンマ
	buffer_sharedStatusMem[6] = 0x30;	//制御車両数(0-15, 16進数)
	buffer_sharedStatusMem[7] = 0x2c;	//カンマ
	buffer_sharedStatusMem[8] = 0x30;	//電圧
	buffer_sharedStatusMem[9] = 0x30;
	buffer_sharedStatusMem[10] = 0x30;
	buffer_sharedStatusMem[11] = 0x2c;	//カンマ
	buffer_sharedStatusMem[12] = 0x30;	//電流
	buffer_sharedStatusMem[13] = 0x30;
	buffer_sharedStatusMem[14] = 0x2c;	//カンマ
	buffer_sharedStatusMem[15] = 0x30;	//HW version
	buffer_sharedStatusMem[16] = 0x2c;	//カンマ
	buffer_sharedStatusMem[17] = 0x30;	//送信回数
	buffer_sharedStatusMem[18] = 0x30;	//送信回数（生存チェック)
	buffer_sharedStatusMem[19] = 0x2c;	//カンマ
	buffer_sharedStatusMem[20] = 0x30;	//S88 MAX
	buffer_sharedStatusMem[21] = 0x30;	//S88 1L
	buffer_sharedStatusMem[22] = 0x30;	//S88 1H
	buffer_sharedStatusMem[23] = 0x30;	//S88 2L
	buffer_sharedStatusMem[24] = 0x30;	//S88 2H
	buffer_sharedStatusMem[25] = 0x30;	//S88 3L
	buffer_sharedStatusMem[26] = 0x30;	//S88 3H
	buffer_sharedStatusMem[27] = 0x30;	//S88 4L
	buffer_sharedStatusMem[28] = 0x30;	//S88 4H
	buffer_sharedStatusMem[29] = 0x30;	//S88 reserved
	buffer_sharedStatusMem[30] = 0x30;	//S88 reserved
	buffer_sharedStatusMem[31] = 0x3b;

	//CV
	for (int i = 0; i < 15; i++)
	{
		buffer_sharedStatusMem[32 + i] = 0x30;
	}

	buffer_sharedStatusMem[47] = 0x3b;

	//ポイント

	for (int i = 0; i < SHAREMEM_ACCSIZE; i++)
	{
		buffer_sharedStatusMem[48 + i *2] = 0x30;
		buffer_sharedStatusMem[48 + i *2 + 1] = 0x30;
	}

	buffer_sharedStatusMem[112] = 0x3b;	//;

	//アクティブな車両データ(最新5つ)

	for (int i = 0; i < MAX_LOCSTATUS_WEB; i++)
	{
		buffer_sharedStatusMem[113 + i *19] = 0x30;	//LocAddr
		buffer_sharedStatusMem[113 + i *19 + 1] = 0x30;	//LocAddr
		buffer_sharedStatusMem[113 + i *19 + 2] = 0x30;	//LocAddr
		buffer_sharedStatusMem[113 + i *19 + 3] = 0x30;	//LocAddr
		buffer_sharedStatusMem[113 + i *19 + 4] = 0x2C;	//,
		buffer_sharedStatusMem[113 + i *19 + 5] = 0x30;	//Spd
		buffer_sharedStatusMem[113 + i *19 + 6] = 0x30;	//Spd
		buffer_sharedStatusMem[113 + i *19 + 7] = 0x2C;	//,
		buffer_sharedStatusMem[113 + i *19 + 8] = 0x30;	//Dir
		buffer_sharedStatusMem[113 + i *19 + 9] = 0x2C;	//,
		buffer_sharedStatusMem[113 + i *19 + 10] = 0x30;	//Fnc
		buffer_sharedStatusMem[113 + i *19 + 11] = 0x30;	//Fnc
		buffer_sharedStatusMem[113 + i *19 + 12] = 0x30;	//Fnc
		buffer_sharedStatusMem[113 + i *19 + 13] = 0x30;	//Fnc
		buffer_sharedStatusMem[113 + i *19 + 14] = 0x30;	//Fnc
		buffer_sharedStatusMem[113 + i *19 + 15] = 0x30;	//Fnc
		buffer_sharedStatusMem[113 + i *19 + 16] = 0x30;	//Fnc
		buffer_sharedStatusMem[113 + i *19 + 17] = 0x30;	//Fnc
		buffer_sharedStatusMem[113 + i *19 + 18] = 0x2f;	///
	}
}

void ShareMemManager::RegisterShareMem(uint8_t inNumber, uint8_t inValue)
{
	/*
	  0x1000-0x107F FlashAir→Arduino コマンド
	  0x1080-0x10AF ステータス
	  0x10B0-0x10C0 CV Reply
	*/

	char aTxtBuf[5];

	switch (inNumber)
	{
		case SMEM_POWER:
			//Power
			buffer_sharedStatusMem[0] = (inValue == 1) ? 0x59 : 0x4e;
			break;

		case SMEM_ERROR:
			//ErrorCode
			sprintf(aTxtBuf, "%d", inValue);	//0x00は無効
			buffer_sharedStatusMem[2] = aTxtBuf[0];
			break;

		case SMEM_EDC:
			//電圧
			sprintf(aTxtBuf, "%03d", inValue);	//0x00は無効
			buffer_sharedStatusMem[8] = aTxtBuf[0];
			buffer_sharedStatusMem[9] = aTxtBuf[1];
			buffer_sharedStatusMem[10] = aTxtBuf[2];

			break;

		case SMEM_CUR:
			//電流
			sprintf(aTxtBuf, "%03d", inValue);	//0x00は無効
			buffer_sharedStatusMem[12] = aTxtBuf[0];
			buffer_sharedStatusMem[13] = aTxtBuf[1];
			break;

		case SMEM_SEQ:
			sprintf(aTxtBuf, "%02d", inValue);	//0x00は無効
			buffer_sharedStatusMem[17] = aTxtBuf[0];
			buffer_sharedStatusMem[18] = aTxtBuf[1];
			break;
		case SMEM_S88_1:
			sprintf(aTxtBuf, "%02X", inValue);	//0x00は無効
			buffer_sharedStatusMem[21] = aTxtBuf[0];
			buffer_sharedStatusMem[22] = aTxtBuf[1];
			break;
		case SMEM_S88_2:
			sprintf(aTxtBuf, "%02X", inValue);	//0x00は無効
			buffer_sharedStatusMem[23] = aTxtBuf[0];
			buffer_sharedStatusMem[24] = aTxtBuf[1];
			break;
		case SMEM_S88_3:
			sprintf(aTxtBuf, "%02X", inValue);	//0x00は無効
			buffer_sharedStatusMem[25] = aTxtBuf[0];
			buffer_sharedStatusMem[26] = aTxtBuf[1];
			break;
		case SMEM_S88_4:
			sprintf(aTxtBuf, "%02X", inValue);	//0x00は無効
			buffer_sharedStatusMem[27] = aTxtBuf[0];
			buffer_sharedStatusMem[28] = aTxtBuf[1];
			break;
	}
}

boolean ShareMemManager::WriteSharedMem_CVReply(word inCVNo, uint8_t inValue)
{
	uint8_t i;

	char aBufCVReply[16];

	if ((inCVNo == 0) && (inValue == 0))
	{
		for (i = 0; i < 15; i++)
		{
			buffer_sharedStatusMem[32 + i] = 0x30;
		}
	}
	else
	{
		//@CV,9999,255, (13文字)
		sprintf(aBufCVReply, "@CV,%04d,%03d,  ", inCVNo, inValue);

		for (i = 0; i < 15; i++)
		{
			buffer_sharedStatusMem[32 + i] = aBufCVReply[i];
		}
	}

	return true;
}

void ShareMemManager::LOCMNG_UpdateAccBuffer(word inAccAddr, word inPosition)
{
	
	if (inPosition == 0)
	{
		buffer_accessories[inAccAddr >> 3] = buffer_accessories[inAccAddr >> 3] & ~( 1UL << (inAccAddr & 0x07));
	}
	else
	{
		buffer_accessories[inAccAddr >> 3] = buffer_accessories[inAccAddr >> 3] | ( 1UL << (inAccAddr & 0x07));
	}
}

void ShareMemManager::LOCMNG_UpdateAcc(word inNo)
{
	char aBuf2[3];

	sprintf(aBuf2, "%02x", buffer_accessories[inNo]);

	buffer_sharedStatusMem[48 + inNo *2] = aBuf2[1];
	buffer_sharedStatusMem[48 + inNo *2 + 1] = aBuf2[0];

}

void ShareMemManager::WriteShareMemByte(word inPos, char inValue)
{
	buffer_sharedStatusMem[inPos] = inValue;
	
}

uint8_t *ShareMemManager::GetShareMemPointer()
{
	/* 共有メモリの配列のポインタを返す */
	return buffer_sharedStatusMem;
	
}


void ShareMemManager::LOCMNG_Clear(void)
{
	for (int i = 0; i < MAX_LOCSTATUS_WEB; i++)
	{
		gLocStatus[i].mAddress = 0;
		gLocStatus[i].mSpeed = 0;
		gLocStatus[i].mDir = 0;
		gLocStatus[i].mFuncBuf1 = 0;
		gLocStatus[i].mFuncBuf2 = 0;
	}
}

uint8_t ShareMemManager::LOCMNG_SetLocoSpeed(word inAddr, word inSpd)
{
	uint8_t aIndex = 255;
	word aSpeed = 0;

	for (int i = 0; i < MAX_LOCSTATUS_WEB; i++)
	{
		if ((gLocStatus[i].mAddress == inAddr) || (gLocStatus[i].mAddress == 0))
		{
			aIndex = i;
			break;
		}
	}

	if (aIndex != 255)
	{
		gLocStatus[aIndex].mAddress = inAddr;
		aSpeed = inSpd >> 2;

		if (aSpeed > 255)
		{
			aSpeed = 255;
		}

		char aStrAddr[5];
		char aStrSpd[3];

		sprintf(aStrAddr, "%04X", gLocStatus[aIndex].mAddress);
		sprintf(aStrSpd, "%02X", aSpeed);

		/*FlashAir共有メモリ書き換え */
		WriteShareMemByte(113 + aIndex * 19, aStrAddr[0]);
		WriteShareMemByte(113 + aIndex * 19 + 1, aStrAddr[1]);
		WriteShareMemByte(113 + aIndex * 19 + 2, aStrAddr[2]);
		WriteShareMemByte(113 + aIndex * 19 + 3, aStrAddr[3]);
		WriteShareMemByte(113 + aIndex * 19 + 5, aStrSpd[0]);
		WriteShareMemByte(113 + aIndex * 19 + 6, aStrSpd[1]);
		
		/*
		buffer_sharedStatusMem[113 + aIndex *19] = aStrAddr[0];	//LocAddr
		buffer_sharedStatusMem[113 + aIndex *19 + 1] = aStrAddr[1];	//LocAddr
		buffer_sharedStatusMem[113 + aIndex *19 + 2] = aStrAddr[2];	//LocAddr
		buffer_sharedStatusMem[113 + aIndex *19 + 3] = aStrAddr[3];	//LocAddr
		buffer_sharedStatusMem[113 + aIndex *19 + 5] = aStrSpd[0];	//Spd
		buffer_sharedStatusMem[113 + aIndex *19 + 6] = aStrSpd[1];	//Spd
		*/

	}

	return 0;
}

uint8_t ShareMemManager::LOCMNG_SetLocoDir(word inAddr, uint8_t inDir)
{
	uint8_t aIndex = 255;

	for (int i = 0; i < MAX_LOCSTATUS_WEB; i++)
	{
		if ((gLocStatus[i].mAddress == inAddr) || (gLocStatus[i].mAddress == 0))
		{
			aIndex = i;
			break;
		}
	}

	if (aIndex != 255)
	{
		gLocStatus[aIndex].mAddress = inAddr;

		if (gLocStatus[aIndex].mDir != inDir)
		{
			gLocStatus[aIndex].mDir = inDir;

			WriteShareMemByte(113 + aIndex * 19 + 5, 0x30);
			WriteShareMemByte(113 + aIndex * 19 + 6, 0x30);
			//buffer_sharedStatusMem[] = 0x30;	//Spd
			//buffer_sharedStatusMem[113 + aIndex *19 + 6] = 0x30;	//Spd
		}

		char aStrAddr[5];
		char aStrDir;

		sprintf(aStrAddr, "%04X", gLocStatus[aIndex].mAddress);
		aStrDir = (gLocStatus[aIndex].mDir == 0) ? '0' : '1';

		/*FlashAir共有メモリ書き換え */
		WriteShareMemByte(113 + aIndex * 19, aStrAddr[0]);
		WriteShareMemByte(113 + aIndex * 19 + 1, aStrAddr[1]);
		WriteShareMemByte(113 + aIndex * 19 + 2, aStrAddr[2]);
		WriteShareMemByte(113 + aIndex * 19 + 3, aStrAddr[3]);
		WriteShareMemByte(113 + aIndex * 19 + 8, aStrDir);
		
		/*
		buffer_sharedStatusMem[113 + aIndex *19] = aStrAddr[0];	//LocAddr
		buffer_sharedStatusMem[113 + aIndex *19 + 1] = aStrAddr[1];	//LocAddr
		buffer_sharedStatusMem[113 + aIndex *19 + 2] = aStrAddr[2];	//LocAddr
		buffer_sharedStatusMem[113 + aIndex *19 + 3] = aStrAddr[3];	//LocAddr
		buffer_sharedStatusMem[113 + aIndex *19 + 8] = aStrDir;	//Dir
		*/
	}

	return 0;
}

uint8_t ShareMemManager::LOCMNG_SetLocoFunc(word inAddr, uint8_t inNo, uint8_t inPower)
{
	char aStrAddr[5];
	char aStrFunc1[5];
	char aStrFunc2[5];
	uint8_t aIndex = 255;

	for (int i = 0; i < MAX_LOCSTATUS_WEB; i++)
	{
		if ((gLocStatus[i].mAddress == inAddr) || (gLocStatus[i].mAddress == 0))
		{
			aIndex = i;
			break;
		}
	}

	if (aIndex != 255)
	{
		gLocStatus[aIndex].mAddress = inAddr;
		sprintf(aStrAddr, "%04X", gLocStatus[aIndex].mAddress);

		WriteShareMemByte(113 + aIndex * 19, aStrAddr[0]);
		WriteShareMemByte(113 + aIndex * 19 + 1, aStrAddr[1]);
		WriteShareMemByte(113 + aIndex * 19 + 2, aStrAddr[2]);
		WriteShareMemByte(113 + aIndex * 19 + 3, aStrAddr[3]);

		//buffer_sharedStatusMem[113 + aIndex *19] = aStrAddr[0];	//LocAddr
		//buffer_sharedStatusMem[113 + aIndex *19 + 1] = aStrAddr[1];	//LocAddr
		//buffer_sharedStatusMem[113 + aIndex *19 + 2] = aStrAddr[2];	//LocAddr
		//buffer_sharedStatusMem[113 + aIndex *19 + 3] = aStrAddr[3];	//LocAddr

		if (inPower == 0)
		{
			if (inNo < 16)
			{
				gLocStatus[aIndex].mFuncBuf1 = gLocStatus[aIndex].mFuncBuf1 &~(1 << inNo);
			}
			else
			{
				gLocStatus[aIndex].mFuncBuf2 = gLocStatus[aIndex].mFuncBuf2 &~(1 << (inNo - 16));
			}
		}
		else
		{
			if (inNo < 16)
			{
				gLocStatus[aIndex].mFuncBuf1 = gLocStatus[aIndex].mFuncBuf1 | (1 << inNo);
			}
			else
			{
				gLocStatus[aIndex].mFuncBuf2 = gLocStatus[aIndex].mFuncBuf2 | (1 << (inNo - 16));
			}
		}

		sprintf(aStrFunc1, "%04X", gLocStatus[aIndex].mFuncBuf1);
		sprintf(aStrFunc2, "%04X", gLocStatus[aIndex].mFuncBuf2);

		/*FlashAir共有メモリ書き換え */
		WriteShareMemByte(113 + aIndex * 19 + 10, aStrFunc2[0]);
		WriteShareMemByte(113 + aIndex * 19 + 11, aStrFunc2[1]);
		WriteShareMemByte(113 + aIndex * 19 + 12, aStrFunc2[2]);
		WriteShareMemByte(113 + aIndex * 19 + 13, aStrFunc2[3]);
		WriteShareMemByte(113 + aIndex * 19 + 14, aStrFunc1[0]);
		WriteShareMemByte(113 + aIndex * 19 + 15, aStrFunc1[1]);
		WriteShareMemByte(113 + aIndex * 19 + 16, aStrFunc1[2]);
		WriteShareMemByte(113 + aIndex * 19 + 17, aStrFunc1[3]);
		
		/*
		buffer_sharedStatusMem[113 + aIndex *19 + 10] = aStrFunc2[0];	//Fnc
		buffer_sharedStatusMem[113 + aIndex *19 + 11] = aStrFunc2[1];	//Fnc
		buffer_sharedStatusMem[113 + aIndex *19 + 12] = aStrFunc2[2];	//Fnc
		buffer_sharedStatusMem[113 + aIndex *19 + 13] = aStrFunc2[3];	//Fnc
		buffer_sharedStatusMem[113 + aIndex *19 + 14] = aStrFunc1[0];	//Fnc
		buffer_sharedStatusMem[113 + aIndex *19 + 15] = aStrFunc1[1];	//Fnc
		buffer_sharedStatusMem[113 + aIndex *19 + 16] = aStrFunc1[2];	//Fnc
		buffer_sharedStatusMem[113 + aIndex *19 + 17] = aStrFunc1[3];	//Fnc
		*/
	}

	return 0;
}


